#
# spec file for package uvg266
#
# Copyright (c) 2024 Packman Team <packman@links2linux.de>
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.links2linux.org
#

%define sover   081
Name:           uvg266
Version:        0.8.1
Release:        1699.1.pm.34
Summary:        VVC encoder based on Kvazaar
License:        BSD-3-Clause AND ISC
URL:            https://ultravideo.fi/#encoder
Source0:        https://github.com/ultravideo/uvg266/archive/refs/tags/v%{version}.tar.gz#/%{name}-%{version}.tar.gz
# PATCH-FIX-OPENSUSE uvg266-add_lm.patch
Patch0:         uvg266-add_lm.patch
# PATCH-FIX-OPENSUSE uvg266-add_library_version.patch
Patch1:         uvg266-add_library_version.patch
# PATCH-FIX-OPENSUSE uvg266-fix_no_return_nonvoid.patch
Patch2:         uvg266-fix_no_return_nonvoid.patch
BuildRequires:  cmake
%if 0%{?suse_version} > 1500
BuildRequires:  gcc-c++
%else
BuildRequires:  gcc12
BuildRequires:  gcc12-c++
%endif
BuildRequires:  pkgconfig


%description
A VVC encoder based on Kvazaar.

%package -n lib%{name}_%{sover}
Summary:        VVC encoder based on Kvazaar

%description -n lib%{name}_%{sover}
A VVC encoder based on Kvazaar.

%package devel
Summary:        Development files for lib%{name}_%{sover}
Requires:       lib%{name}_%{sover} = %{version}

%description devel
Contains development files for lib%{name}_%{sover}

%prep
%autosetup -p1
# fix soname
sed -i 's|__VERSION__|%{sover}|g' CMakeLists.txt src/uvg266.pc.in

%build
export CC=cc
export CXX=g++
test -x "$(type -p gcc-12)" && export CC=gcc-12
test -x "$(type -p g++-12)" && export CXX=g++-12
%cmake \
  -DCMAKE_C_COMPILER=$CC \
  -DCMAKE_CXX_COMPILER=$CXX
%cmake_build

%install
%cmake_install

%check

%post -n lib%{name}_%{sover}
/sbin/ldconfig

%postun -n lib%{name}_%{sover}
/sbin/ldconfig

%files
%license LICENSE LICENSE.EXT.greatest
%doc README.md
%{_bindir}/%{name}
%{_mandir}/man1/%{name}.1%{?ext_man}

%files -n lib%{name}_%{sover}
%{_libdir}/lib%{name}-%{sover}.so

%files devel
%{_includedir}/uvg266.h
%{_libdir}/pkgconfig/%{name}.pc

%changelog
* Mon Jul  8 2024 Luigi Baldoni <aloisio@gmx.com>
- Update to version 0.8.1
  * Fix small problems in Dependent Quantization code
  * Fix for MTS bitcost estimation
  * Add selection of VVC tools to the presets
  * Update flow control to print CTU stats to stats file when
    the stats-file-prefix is set
  * Remove incorrect AVX2 define
- Refresh uvg266-fix_no_return_nonvoid.patch
* Wed Sep 27 2023 Luigi Baldoni <aloisio@gmx.com>
- Update to version 0.8.0
  * Add experimental support for intra sub partition (ISP)
    requires disabling some of the AVX2 optimizations, see
    e32cf4f
  * Add experimental support for multi type tree (MTT) for intra
    slices, similarly to ISP requires disabling some AVX2
    optimizations e32cf4f
  * Support for dependent quantization (DQ)
  * Experimental support for intra block copy (IBC) not
    guaranteed to have positive impact in most cases, primarly
    intented for screen content coding
  * AVX2 optimizations for non-square transform blocks
  * AVX2 optimizations for DQ
  * Simplify the dual-tree implementation and enable 2 height
    chroma block with dual tree
  * Fix several issues in rate distortion cost calculation
- Add uvg266-fix_no_return_nonvoid.patch and
  uvg266-fix_i586_build.patch
* Wed Jan  4 2023 Luigi Baldoni <aloisio@gmx.com>
- Initial package (v0.4.1)
